package bmci.esign.backendend.controllers;


import bmci.esign.backendend.dto.DemandeDto;
import bmci.esign.backendend.models.ResponseModelStandard;
import bmci.esign.backendend.models.enums.EStatut;
import bmci.esign.backendend.services.DemandeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/demande")
public class DemandeController {

        @Autowired
        private DemandeService demandeService;

        @PostMapping("/add")
        public ResponseModelStandard<Long> addDemande(@RequestBody DemandeDto demandeDto){
                System.out.println("ggg");
                System.out.println("ggg");
                try {
                        demandeService.addDemande(demandeDto);
                        return new ResponseModelStandard<>("000");
                }catch (Exception e){
                        return new ResponseModelStandard<>("099");
                }
        }

        @GetMapping("/get")
        public ResponseModelStandard<DemandeDto> getDemande(@RequestParam( name = "id") Long id){
                try {
                      DemandeDto demandeDto =  demandeService.getDemande(id);
                        return new ResponseModelStandard<>("000", demandeDto);
                }catch (Exception e){
                        return new ResponseModelStandard<>("099");
                }
        }

        @GetMapping("/relaunch")
        public ResponseModelStandard<Long> relaunchDemande(@RequestParam( name = "idDemand") Long id,
                                                           @RequestParam(name = "idDestinataire") Long idDestinataire){
                try {
                        String message =  demandeService.relaunchUser(id, idDestinataire);
                        if(message.equals("success")){
                                return new ResponseModelStandard<>("000");
                        }
                        return new ResponseModelStandard<>("099");
                }catch (Exception e){
                        return new ResponseModelStandard<>("099");
                }
        }

        @GetMapping("/canceled")
        public ResponseModelStandard<Long> canceledDemande(@RequestParam( name = "idDemand") Long id){
                try {
                        DemandeDto demandeDto = demandeService.getDemande(id);
                        if(demandeDto.getStatut().equals(EStatut.WAITING.name())){
                                String message =  demandeService.cancelDemand(demandeDto);
                                if(message.equals("success")){
                                        return new ResponseModelStandard<>("000");
                                }
                        }
                        return new ResponseModelStandard<>("099");
                }catch (Exception e){
                        return new ResponseModelStandard<>("099");
                }
        }

        @GetMapping("/getForUser")
        public ResponseModelStandard<List<DemandeDto>> getForUserDemande(@RequestParam(name = "id") Long id){
                try {
                        List<DemandeDto> demandeDtoList = demandeService.getAllbyUser(id);
                        return new ResponseModelStandard<>("000",demandeDtoList);
                }catch (Exception e){
                        return new ResponseModelStandard<>("099");
                }
        }

        @GetMapping("/getForUser/search")
        public ResponseModelStandard<Map<String, Object>> getForUserDemandeSearch(@RequestParam(name = "id") Long id,
                                                                                  @RequestParam(name = "page") int page,
                                                                                  @RequestParam(name = "limit") int limit,
                                                                                  @RequestParam(name = "statut") String statut,
                                                                                  @RequestParam(name = "eDemande") String eDemande,
                                                                                  @RequestParam(name = "date") @DateTimeFormat(pattern = "yyyy-MM-dd") Date dateStart){
                try {
                        Map<String, Object> demandeDtoList = demandeService.getForUserDemandeSearch(id, page, limit, statut,eDemande, dateStart);
                        return new ResponseModelStandard<>("000",demandeDtoList);
                }catch (Exception e){
                        return new ResponseModelStandard<>("099");
                }
        }


}
