package bmci.esign.backendend.models;


import bmci.esign.backendend.models.enums.EMailStatus;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.util.Date;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Entity
public class MailRequest {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String destination;
    private String email_type;
    private long demandeId;
    private String processCamundaId ;
    @Column(unique = true)
    private String token;
    private String expiration_date;
    private String name;
    private String userMessage;
    private EMailStatus status;
    private String responseMessage;
    private String url_sign;
    @CreationTimestamp
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;
    @UpdateTimestamp
    @Temporal(TemporalType.TIMESTAMP)
    private Date modificationDate;

}
