package bmci.esign.backendend.models;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Set;

@Data
@NoArgsConstructor @AllArgsConstructor
@Entity
@Table(name = "userEntity")
public class User {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    @Column(length = 120)
    private String firstname;
    @Column(length = 120)
    private String lastname;
    private String avatar;
    @Column(unique = true)
    private String email;
    @Column(length = 60)
    private String password;
    @CreationTimestamp
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;
    @UpdateTimestamp
    @Temporal(TemporalType.TIMESTAMP)
    private Date modificationDate;

    @OneToMany(mappedBy = "user") @JsonIgnore
    private List<Demande> demandes = new ArrayList<>();

    @OneToMany(mappedBy = "user") @JsonIgnore
    private List<Signature> signatures = new ArrayList<>();

    @ManyToMany(fetch = FetchType.EAGER)
    @JoinTable(	name = "user_authority",
            joinColumns = @JoinColumn(name = "user_id"),
            inverseJoinColumns = @JoinColumn(name = "authority_id")
    )
    private Set<Authority> authorities;
}
